// 004 xxx
// 05 nov 2007

// -- Copyright (C) Felix John COLIBRI 2004 - All Rigths Reserved
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit a_42_enter_profile;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  System.Web.Security, System.Web.UI.WebControls.WebParts, System.Configuration,
  Borland.Data.DataStore, Borland.Data.AdoDbxClientProvider
    // for provider test
(*
    uses System.Collections.Specialized
        , System.Web
*)
        , System.Web.Profile
        ;

type
  TDefault = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure add_profile__Click(sender: System.Object; e: System.EventArgs);
    procedure delete_all_profile__Click(sender: System.Object; e: System.EventArgs);
    procedure clear_display__Click(sender: System.Object; e: System.EventArgs);
    procedure fill_users_profile__Click(sender: System.Object; e: System.EventArgs);
    procedure list_users__Click(sender: System.Object; e: System.EventArgs);
    procedure list_profiles__Click(sender: System.Object; e: System.EventArgs);
    procedure get_all_profiles__Click(sender: System.Object; e: System.EventArgs);
    procedure list_user_profiles__Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    DataStoreConnection1: Borland.Data.DataStore.DataStoreConnection;
    general_command_: Borland.Data.DataStore.DataStoreCommand;
    TextBox1: System.Web.UI.WebControls.TextBox;
    add_profile_: System.Web.UI.WebControls.Button;
    insert_profile_comand_: Borland.Data.DataStore.DataStoreCommand;
    userid_textbox_: System.Web.UI.WebControls.TextBox;
    delete_all_profile_: System.Web.UI.WebControls.Button;
    list_profile_: System.Web.UI.WebControls.Button;
    street_textbox_: System.Web.UI.WebControls.TextBox;
    clear_display_: System.Web.UI.WebControls.Button;
    drop_profile_: System.Web.UI.WebControls.Button;
    drop_membership_: System.Web.UI.WebControls.Button;
    create_usersinprofile_: System.Web.UI.WebControls.Button;
    add_userinprofile_: System.Web.UI.WebControls.Button;
    delete_usersinprofile_: System.Web.UI.WebControls.Button;
    drop_usersinprofile_: System.Web.UI.WebControls.Button;
    list_usersinprofile_: System.Web.UI.WebControls.Button;
    user_listbox_: System.Web.UI.WebControls.ListBox;
    DataStoreSelectCommand1: Borland.Data.DataStore.DataStoreCommand;
    DataStoreInsertCommand1: Borland.Data.DataStore.DataStoreCommand;
    DataStoreUpdateCommand1: Borland.Data.DataStore.DataStoreCommand;
    DataStoreDeleteCommand1: Borland.Data.DataStore.DataStoreCommand;
    DataStoreDataAdapter1: Borland.Data.DataStore.DataStoreDataAdapter;
    DataSet1: System.Data.DataSet;
    DataTable1: System.Data.DataTable;
    DataTable2: System.Data.DataTable;
    list_users_: System.Web.UI.WebControls.Button;
    // list_profile_: System.Web.UI.WebControls.Button;
    list_profiles_: System.Web.UI.WebControls.Button;
    Label1: System.Web.UI.WebControls.Label;
    firstname_textbox_: System.Web.UI.WebControls.TextBox;
    city_textbox_: System.Web.UI.WebControls.TextBox;
    zip_textbox_: System.Web.UI.WebControls.TextBox;
    state_textbox_: System.Web.UI.WebControls.TextBox;
    get_all_profiles_: System.Web.UI.WebControls.Button;
    list_user_profiles_: System.Web.UI.WebControls.Button;
    username_textbox_: System.Web.UI.WebControls.TextBox;
  protected
    procedure OnInit(e: EventArgs); override;
  private
    { Private Declarations }
  public
    procedure display(p_text: String);
    procedure clear_display;

    function GetAllProfiles(p_authenticationi_option: ProfileAuthenticationOption;
        p_page_index: Integer; p_page_size: Integer; out pv_total_records: Integer): ProfileInfoCollection;
    function FindProfilesByUserName(p_authentication_option: ProfileAuthenticationOption;
        p_user_name_to_match: string; p_page_index: Integer; p_page_size: Integer; out pv_total_records: Integer): ProfileInfoCollection;
  end;

implementation
  uses system.data.common // dbConnection

    // for provider test
(*
    uses System.Collections.Specialized
        , System.Web
*)
        // , System.Web.Profile
(*
        , System.Configuration
       , System.Collections
*)
   ;

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TDefault.InitializeComponent;
type
  TArrayOfSystem_Data_DataTable = array of System.Data.DataTable;
begin
  Self.general_command_ := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.DataStoreConnection1 := Borland.Data.DataStore.DataStoreConnection.Create;
  Self.insert_profile_comand_ := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.DataStoreSelectCommand1 := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.DataStoreInsertCommand1 := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.DataStoreUpdateCommand1 := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.DataStoreDeleteCommand1 := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.DataStoreDataAdapter1 := Borland.Data.DataStore.DataStoreDataAdapter.Create;
  Self.DataSet1 := System.Data.DataSet.Create;
  Self.DataTable1 := System.Data.DataTable.Create;
  Self.DataTable2 := System.Data.DataTable.Create;
  (System.ComponentModel.ISupportInitialize(Self.DataStoreDataAdapter1)).BeginInit;
  (System.ComponentModel.ISupportInitialize(Self.DataSet1)).BeginInit;
  (System.ComponentModel.ISupportInitialize(Self.DataTable1)).BeginInit;
  (System.ComponentModel.ISupportInitialize(Self.DataTable2)).BeginInit;
  Include(Self.add_profile_.Click, Self.add_profile__Click);
  Include(Self.delete_all_profile_.Click, Self.delete_all_profile__Click);
  Include(Self.list_profiles_.Click, Self.list_profiles__Click);
  Include(Self.clear_display_.Click, Self.clear_display__Click);
  Include(Self.list_users_.Click, Self.list_users__Click);
  Include(Self.get_all_profiles_.Click, Self.get_all_profiles__Click);
  Include(Self.list_user_profiles_.Click, Self.list_user_profiles__Click);
  // 
  // general_command_
  // 
  Self.general_command_.CommandText := nil;
  Self.general_command_.CommandTimeout := 0;
  Self.general_command_.Connection := Self.DataStoreConnection1;
  // 
  // DataStoreConnection1
  // 
  Self.DataStoreConnection1.ConnectionString := 'host=LocalHost;database=C:\' +
  'programs\us\web\asp_net\membership_roles_profile\_data\bfs_membership_man' +
  'ual.jds;user=SYSDBA;password=masterkey';
  // 
  // insert_profile_comand_
  // 
  Self.insert_profile_comand_.CommandText := nil;
  Self.insert_profile_comand_.CommandTimeout := 0;
  Self.insert_profile_comand_.Connection := Self.DataStoreConnection1;
  Self.insert_profile_comand_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_profile_comand_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_profile_comand_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_profile_comand_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_profile_comand_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.Timestamp, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  // 
  // DataStoreSelectCommand1
  // 
  Self.DataStoreSelectCommand1.CommandText := nil;
  Self.DataStoreSelectCommand1.CommandTimeout := 0;
  Self.DataStoreSelectCommand1.Connection := nil;
  // 
  // DataStoreInsertCommand1
  // 
  Self.DataStoreInsertCommand1.CommandText := nil;
  Self.DataStoreInsertCommand1.CommandTimeout := 0;
  Self.DataStoreInsertCommand1.Connection := nil;
  // 
  // DataStoreUpdateCommand1
  // 
  Self.DataStoreUpdateCommand1.CommandText := nil;
  Self.DataStoreUpdateCommand1.CommandTimeout := 0;
  Self.DataStoreUpdateCommand1.Connection := nil;
  // 
  // DataStoreDeleteCommand1
  // 
  Self.DataStoreDeleteCommand1.CommandText := nil;
  Self.DataStoreDeleteCommand1.CommandTimeout := 0;
  Self.DataStoreDeleteCommand1.Connection := nil;
  // 
  // DataStoreDataAdapter1
  // 
  Self.DataStoreDataAdapter1.DataSet := nil;
  Self.DataStoreDataAdapter1.DeleteCommand := Self.DataStoreDeleteCommand1;
  Self.DataStoreDataAdapter1.InsertCommand := Self.DataStoreInsertCommand1;
  Self.DataStoreDataAdapter1.SelectCommand := Self.DataStoreSelectCommand1;
  Self.DataStoreDataAdapter1.UpdateCommand := Self.DataStoreUpdateCommand1;
  // 
  // DataSet1
  // 
  Self.DataSet1.DataSetName := 'NewDataSet';
  Self.DataSet1.Tables.AddRange(TArrayOfSystem_Data_DataTable.Create(Self.DataTable1, 
          Self.DataTable2));
  // 
  // DataTable1
  // 
  Self.DataTable1.TableName := 'Table1';
  // 
  // DataTable2
  // 
  Self.DataTable2.TableName := 'Table2';
  Include(Self.Load, Self.Page_Load);
  (System.ComponentModel.ISupportInitialize(Self.DataStoreDataAdapter1)).EndInit;
  (System.ComponentModel.ISupportInitialize(Self.DataSet1)).EndInit;
  (System.ComponentModel.ISupportInitialize(Self.DataTable1)).EndInit;
  (System.ComponentModel.ISupportInitialize(Self.DataTable2)).EndInit;
end;
{$ENDREGION}

    procedure TDefault.display(p_text: String);
      begin
        TextBox1.Text:= TextBox1.Text+ p_text+ chr(13)+ chr(10);
      end; // display

    procedure TDefault.clear_display;
      begin
        TextBox1.Text:= '';
      end; // clear_display

    procedure TDefault.OnInit(e: EventArgs);
      begin
        //
        // Required for Designer support
        //
        InitializeComponent;
        inherited OnInit(e);
      end; // OnInit

    procedure TDefault.Page_Load(sender: System.Object; e: System.EventArgs);
      begin
        // TODO: Put profile code to initialize the page here
        if not IsPostback
          then fill_users_profile__Click(Nil, Nil);
      end; // Page_Load

    procedure TDefault.clear_display__Click(sender: System.Object; e: System.EventArgs);
      begin
        clear_display;
      end; // clear_display__Click

    procedure execute_datastore_command(p_c_datastore_command: DataStoreCommand;
        p_request: String);
        // -- assumes the connection is open
      begin
        with p_c_datastore_command do
        begin
          CommandText:= p_request;
          ExecuteNonQuery;
        end; // with p_c_datastore_command
      end; // execute_datastore_command

    function f_list_datastore(p_c_datastore_command: DataStoreCommand;
        p_select_request: String): String;
        // -- assumes the connection is open
      var l_c_db_datareader: dbDataReader;
          l_column_index: Integer;
          l_row_display: String;
      begin
        with p_c_datastore_command do
        begin
          CommandText:= p_select_request;
          l_c_db_datareader:= ExecuteReader;

          Result:= '';

          while l_c_db_datareader.Read do
          begin
            l_row_display:= '';
            for l_column_index:= 0 to l_c_db_datareader.FieldCount- 1 do
              l_row_display:= l_row_display+ l_c_db_datareader.GetString(l_column_index)+ ' ';
            Result:= Result+ l_row_display+ '<BR>'+ chr(13)+ chr(10);
          end; // while l_c_db_datareader.Read
        end; // with p_c_datastore_command
      end; // f_list_datastore

    // -- display users

    procedure TDefault.list_users__Click(sender: System.Object; e: System.EventArgs);
      begin
        display('> list_users');
        DataStoreConnection1.Open;
        display(f_list_datastore(general_command_, 'SELECT userid FROM aspnet_users'));
        DataStoreConnection1.Close;
        display('< list_users');
      end; // list_users__Click

    procedure TDefault.fill_users_profile__Click(sender: System.Object; e: System.EventArgs);
      begin
        display('> fill_users_profile');
        DataStoreConnection1.Open;

        general_command_.CommandText:= 'SELECT userid FROM aspnet_users';
        DataStoreDataAdapter1.SelectCommand:= general_command_;
        DataStoreDataAdapter1.Fill(DataSet1.Tables[0]);
        user_listbox_.DataSource:= DataSet1.Tables[0].DefaultView;
        user_listbox_.DataTextField:= 'userid';

        DataBind;
        DataStoreConnection1.Close;
        display('< fill_users_profile');
      end; // fill_users_profile__Click

    // -- profile

    const k_add_profile_request=
              'INSERT INTO aspnet_profile'
            + '  (userid, propertynames'
            + '    , propertyvaluesstring, propertyvaluesbinary'
            + '    , lastupdateddate)'
            + '  VALUES (?, ?, ?, ?, ? )'
            ;

    type t_array_of_string= array of string;

    procedure array_to_profile_strings(p_property_name_array, p_property_array: t_array_of_string;
        var pv_property_string, pv_value_string: String);
      // -- assumes all types are String (not binary)
      var l_property_index: Integer;
          l_property_name, l_property_value: String;
          l_property_length, l_position: Integer;
      begin
        pv_property_string:= ''; pv_value_string:= '';
        l_position:= 0;
        for l_property_index:= 0 to Length(p_property_array)- 1 do
        begin
          l_property_name:= p_property_name_array[l_property_index];
          l_property_value:= p_property_array[l_property_index];
          l_property_length:= Length(l_property_value);

          pv_value_string:= pv_value_string+ l_property_value;

          if pv_property_string<> ''
            then pv_property_string:= pv_property_string+ ':';
          pv_property_string:= pv_property_string+ l_property_name
              + ':S:'+ l_position.ToString+ ':' + l_property_length.ToString;

          Inc(l_position, l_property_length);
        end; // for l_property_index
      end; // array_to_profile_strings

    procedure TDefault.add_profile__Click(sender: System.Object; e: System.EventArgs);
      var l_property_name_array: t_array_of_string;
          l_property_value_array: t_array_of_string;

      procedure fill_property_arrays;
        begin
          SetLength(l_property_name_array, 5);
          SetLength(l_property_value_array, 5);

          l_property_name_array[0]:= 'Name';
          l_property_value_array[0]:= firstname_textbox_.Text;
          l_property_name_array[1]:= 'Street';
          l_property_value_array[1]:= street_textbox_.Text;
          l_property_name_array[2]:= 'City';
          l_property_value_array[2]:= city_textbox_.Text;
          l_property_name_array[3]:= 'Zip';
          l_property_value_array[3]:= zip_textbox_.Text;
          l_property_name_array[4]:= 'State';
          l_property_value_array[4]:= state_textbox_.Text;
        end; // fill_property_arrays

      var l_property_name_string, l_property_value_string: String;

      begin // add_profile__Click
        display('> add_profile');

        fill_property_arrays;

        array_to_profile_strings(l_property_name_array,
            l_property_value_array,
            // l_property_name_string,
            l_property_name_string, l_property_value_string);

        display(l_property_name_string);
        display(l_property_value_string);

        display(k_add_profile_request);

        DataStoreConnection1.Open;

        insert_profile_comand_.CommandText:= k_add_profile_request;
        insert_profile_comand_.Prepare;

        insert_profile_comand_.Parameters[0].Value:= userid_textbox_.Text;
        insert_profile_comand_.Parameters[1].Value:= l_property_name_string;
        insert_profile_comand_.Parameters[2].Value:= l_property_value_string;
        insert_profile_comand_.Parameters[3].Value:= '';
        insert_profile_comand_.Parameters[4].Value:= DateTime.Now;

        insert_profile_comand_.ExecuteNonQuery;

        DataStoreConnection1.Close;

        display('< add_profile');
      end; // add_profile__Click

    procedure TDefault.delete_all_profile__Click(sender: System.Object; e: System.EventArgs);
      begin
        display('> delete_all_profile');
        DataStoreConnection1.Open;
        execute_datastore_command(general_command_, 'DELETE FROM aspnet_profile');
        DataStoreConnection1.Close;
        display('< delete_all_profile');
      end; // delete_all_profile__Click

    procedure TDefault.list_profiles__Click(sender: System.Object; e: System.EventArgs);
      var l_c_db_datareader: dbDataReader;
          l_column_index: Integer;
          l_row_display: String;
      begin
        display('> list_all_profile');
        DataStoreConnection1.Open;
        general_command_.CommandText:= 'SELECT * FROM aspnet_profile';
        l_c_db_datareader:= general_command_.ExecuteReader;

        while l_c_db_datareader.Read do
        begin
          // display(l_c_db_datareader.GetString(0)); // + ' '+ l_c_db_reader.GetString(1));;
          l_row_display:= '';
          for l_column_index:= 0 to l_c_db_datareader.FieldCount- 1 do
            l_row_display:= l_row_display+ l_c_db_datareader.GetString(l_column_index)+ ' ';
          display(l_row_display);
        end; // while l_c_db_datareader.Read

        DataStoreConnection1.Close;
        display('< list_all_profile');
      end; // list_profile__Click

    // -- trialse for ProfileProvider

    function TDefault.GetAllProfiles(p_authenticationi_option: ProfileAuthenticationOption;
        p_page_index: Integer; p_page_size: Integer; out pv_total_records: Integer): ProfileInfoCollection;
        // -- (All, Anonymous, Authenticated)
        // -- todo: check authentication

      const k_select_profile_request=
               // 'SELECT u.username, u.lastactivitydate, p.lastUpdatedDate'
               'SELECT u.username, u.lastactivitydata, p.lastUpdatedDate'
             + '  FROM aspnet_users u, aspnet_profile p'
             + '  WHERE u.userid= p.userid'
             ;

      var l_c_db_connection: dbConnection;
          l_c_db_command: DbCommand;
          l_c_db_datareader: dbDataReader;

          l_start_index, l_end_index: Integer;
          l_current_count: Integer;

          l_c_profile_info: ProfileInfo;
      begin
        Result:= ProfileInfoCollection.Create;

(*
        l_c_db_connection:= Borland.Data.DataStore.DataStoreConnection.Create;
        l_c_db_connection.ConnectionString:= m_connection_string;
*)
        l_c_db_connection:= DataStoreConnection1;
        
        l_c_db_connection.Open;

        l_c_db_command:= DataStoreCommand.Create;
        l_c_db_command.Connection:= l_c_db_connection;
        l_c_db_command.CommandText:= k_select_profile_request;

        l_c_db_datareader:= l_c_db_command.ExecuteReader;

        l_start_index:= p_page_index* p_page_size;
        l_end_index:= l_start_index+ p_page_size- 1;
        l_current_count:= 0;

        while l_c_db_datareader.Read do
        begin
          if l_current_count>= l_start_index
            then begin
(*
 string username,
 bool isAnonymous,
 DateTime lastActivityDate,
 DateTime lastUpdatedDate,
 int size
*)
                l_c_profile_info:= ProfileInfo.Create(
                    l_c_db_datareader.GetString(0),
                    False,
                    l_c_db_datareader.GetDateTime(1),
                    l_c_db_datareader.GetDateTime(2),
                    333)
                    ;
                Result.Add(l_c_profile_info);
              end;
          if l_current_count>= l_end_index
            then begin
                l_c_db_command.Cancel;
                Break;
              end;
          Inc(l_current_count);
        end; // while l_c_db_datareader.Read

        l_c_db_connection.Close;
      end; // GetAllProfiles

    procedure TDefault.get_all_profiles__Click(sender: System.Object; e: System.EventArgs);
      var l_c_profile_info_collection: ProfileInfoCollection;
          l_profile_count: Integer;
          // l_profile_info_index: Integer;
          l_i_user_enumerator: iEnumerator;
      begin
        l_c_profile_info_collection:= GetAllProfiles(ProfileAuthenticationOption.All,
            0, 10, l_profile_count);

(*
        for l_profile_info_index:= 0 to l_c_profile_info_collection.Count- 1 do
          with l_c_profile_info_collection.Item[l_profile_info_index] do
            display(UserName);
*)
        display('count '+ l_c_profile_info_collection.Count.ToString);

        l_i_user_enumerator:= l_c_profile_info_collection.GetEnumerator;
        while l_i_user_enumerator.MoveNext do
          with l_i_user_enumerator.Current as ProfileInfo do
            display(UserName);
      end; // get_all_profiles__Click

    function TDefault.FindProfilesByUserName(
        p_authentication_option: ProfileAuthenticationOption;
        p_user_name_to_match: string;
        p_page_index: Integer; p_page_size: Integer;
        out pv_total_records: Integer): ProfileInfoCollection;

      const k_select_profile_request=
               'SELECT u.username, u.lastactivitydata, p.lastUpdatedDate'
             + '  FROM aspnet_users u, aspnet_profile p'
             + '  WHERE (u.userid= p.userid)'
             + '      AND (u.username= ?)'
             ;

      var l_c_db_connection: dbConnection;
          l_c_db_command: DbCommand;
          l_c_db_datareader: dbDataReader;

          l_c_datastore_parameter: DataStoreParameter;

          l_start_index, l_end_index: Integer;
          l_current_count: Integer;

          l_c_profile_info: ProfileInfo;
      begin
        Result:= ProfileInfoCollection.Create;

(*
        l_c_db_connection:= Borland.Data.DataStore.DataStoreConnection.Create;
        l_c_db_connection.ConnectionString:= m_connection_string;
*)
        l_c_db_connection:= DataStoreConnection1;

        l_c_db_connection.Open;

        l_c_db_command:= DataStoreCommand.Create;
        l_c_db_command.Connection:= l_c_db_connection;
        l_c_db_command.CommandText:= k_select_profile_request;

        l_c_datastore_parameter:= DataStoreParameter.Create('user_param',
            Borland.Data.DataStore.DataStoreType.VarChar);
        l_c_db_command.Parameters.Add(l_c_datastore_parameter);

        l_c_db_command.Prepare;

        l_c_datastore_parameter.Value:= p_user_name_to_match;
        l_c_db_datareader:= l_c_db_command.ExecuteReader;

        l_start_index:= p_page_index* p_page_size;
        l_end_index:= l_start_index+ p_page_size- 1;
        l_current_count:= 0;

        while l_c_db_datareader.Read do
        begin
          if l_current_count>= l_start_index
            then begin
                l_c_profile_info:= ProfileInfo.Create(
                    l_c_db_datareader.GetString(0),
                    False,
                    l_c_db_datareader.GetDateTime(1),
                    l_c_db_datareader.GetDateTime(2),
                    333)
                    ;
                Result.Add(l_c_profile_info);
              end;
          if l_current_count>= l_end_index
            then begin
                l_c_db_command.Cancel;
                Break;
              end;
          Inc(l_current_count);
        end; // while l_c_db_datareader.Read

        l_c_db_connection.Close;
      end; // FindProfilesByUserName

    procedure TDefault.list_user_profiles__Click(sender: System.Object; e: System.EventArgs);
      var l_c_profile_info_collection: ProfileInfoCollection;
          l_profile_count: Integer;
          l_i_user_enumerator: iEnumerator;
      begin
        l_c_profile_info_collection:= FindProfilesByUserName(ProfileAuthenticationOption.All,
            username_textbox_.Text,
            0, 10, l_profile_count);

        display('count '+ l_c_profile_info_collection.Count.ToString);

        l_i_user_enumerator:= l_c_profile_info_collection.GetEnumerator;
        while l_i_user_enumerator.MoveNext do
          with l_i_user_enumerator.Current as ProfileInfo do
            display(UserName);
      end; // list_user_profiles__Click

    end.


